function updateOK()
{
	var acceptButton = document.getElementById("birthdaymanager-window").getButton("accept");
	if(getElementValue("birthday-title").length == 0)
	{
		acceptButton.setAttribute("disabled", "true");
	} else if (acceptButton.getAttribute("disabled"))
	{
		acceptButton.removeAttribute("disabled");
	}
}
function onLoad()
{
    var args = window.arguments[0];

    window.onAcceptCallback = args.onOk;
    window.calendarItem = args.calendarEvent;
    window.mode = args.mode;
    window.recurrenceInfo = null;

    if (window.calendarItem.calendar && window.calendarItem.calendar.readOnly) {
        gReadOnlyMode = true;
    }


    loadDialog(window.calendarItem);

    // figure out what the title of the dialog should be and set it
    updateTitle();

    // update our size!
    window.sizeToContent();

    document.getElementById("birthday-title").focus();

    //opener.setCursor("auto");

    self.focus();
}


function CreateBirthday()
{
// if this event isn't mutable, we need to clone it like a sheep
    var originalItem = window.calendarItem;
    var item = (originalItem.isMutable) ? originalItem : originalItem.clone();
    saveBirthday(item);
//    var calendar = document.getElementById("item-calendar").selectedItem.calendar;
    var calendars = getCalendarManager().getCalendars({});
    for (i in calendars) {
        var calendar = calendars[i];
	  if (calendar.name=='BirthdayManager')
	  {
		  var BMcalendar=calendar;
	  }
    }

    window.onAcceptCallback(item, BMcalendar, originalItem);
    // We already set persist="collapsed" in the xul file, but because
    // of a bug on 1_8_BRANCH we need this to make it really persist.
    document.persist("description-row", "collapsed");

    return true;
}

function saveBirthday(item)
{
    setItemProperty(item, "title", getElementValue("birthday-title"));

    var kDefaultTimezone = window.opener.calendarDefaultTimezone();
    if (isEvent(item)) {
        var startDate = jsDateToDateTime(getElementValue("birthday-date"));
        startDate = startDate.getInTimezone(kDefaultTimezone);
        var endDate = jsDateToDateTime(getElementValue("birthday-date"));
        endDate = startDate.getInTimezone(kDefaultTimezone);

        var isAllDay = true /* getElementValue("event-all-day", "checked")*/;
        if (isAllDay) {
            startDate.isDate = true;
            startDate.normalize();

            endDate.isDate = true;
            endDate.day += 1;
            endDate.normalize();
        }
        setItemProperty(item, "startDate",   startDate);
        setItemProperty(item, "endDate",     endDate);
    }
    /* Category */
       item.deleteProperty("CATEGORIES");
	  item.alarmOffset = null;
        item.alarmLastAck = null;
        item.alarmRelated = null;
	  
	  var recurrenceInfo = null;
	  recurrenceInfo = createRecurrenceInfo();
        recurrenceInfo.item = window.calendarItem;
    var recRule = new calRecurrenceRule();
        recRule.type = "YEARLY";
        recRule.count = -1;
    recurrenceInfo.insertRecurrenceItemAt(recRule, 0);
	  
	  item.recurrenceInfo=recurrenceInfo;


       dump(item.icalString + '\n');
        return;
}

function loadDialog(item)
{
    var kDefaultTimezone = window.opener.calendarDefaultTimezone();

    setElementValue("birthday-title",       item.title);
    /* event specific properties */
    if (isEvent(item)) {
        var startDate = item.startDate.getInTimezone(kDefaultTimezone);
        var endDate = item.endDate.getInTimezone(kDefaultTimezone);
        gItemDuration = endDate.subtractDate(startDate);
        
        // Check if an all-day event has been passed in (to adapt endDate).
        if (startDate.isDate) {
            endDate.day -= 1;
            gItemDuration.days -= 1;

            // The date/timepicker uses jsDate internally. Because jsDate does
            // not know the concept of dates we end up displaying times unequal
            // to 00:00 for all-day events depending on local timezone setting. 
            // Calling normalize() recalculates that times to represent 00:00
            // in local timezone.
            endDate.normalize();
            startDate.normalize();
        }
        
        setElementValue("birthday-date",   startDate.jsDate);
    }
}
function updateTitle()
{
    var isNew = window.calendarItem.isMutable;
        if (isNew)
            document.title = "Add New Birthday";//calGetString("calendar", "newEventDialog");
        else
            document.title = "Edit Birthday";//calGetString("calendar", "newEventDialog");
}

function setItemProperty(item, propertyName, value)
{
    switch(propertyName) {
    case "startDate":
        if (value.isDate && !item.startDate.isDate ||
            !value.isDate && item.startDate.isDate ||
            value.timezone != item.startDate.timezone ||
            value.compare(item.startDate) != 0)
            item.startDate = value;
        break;
    case "endDate":
        if (value.isDate && !item.endDate.isDate ||
            !value.isDate && item.endDate.isDate ||
            value.timezone != item.endDate.timezone ||
            value.compare(item.endDate) != 0)
            item.endDate = value;
        break;

    case "entryDate":
        if (value == item.entryDate)
            break;
        if ((value && !item.entryDate) ||
            (!value && item.entryDate) ||
            (value.timezone != item.entryDate.timezone) ||
            (value.compare(item.entryDate) != 0) ||
            (value.isDate != item.entryDate.isDate))
            item.entryDate = value;
        break;
    case "dueDate":
        if (value == item.dueDate)
            break;
        if ((value && !item.dueDate) ||
            (!value && item.dueDate) ||
            (value.timezone != item.dueDate.timezone) ||
            (value.compare(item.dueDate) != 0) ||
            (value.isDate != item.dueDate.isDate))
            item.dueDate = value;
        break;
    case "isCompleted":
        if (value != item.isCompleted)
            item.isCompleted = value;
        break;

    case "title":
        if (value != item.title)
            item.title = value;
        break;

    default:
        if (!value || value == "")
            item.deleteProperty(propertyName);
        else if (item.getProperty(propertyName) != value)
            item.setProperty(propertyName, value);
        break;
    }
}
